###########################################################
#
# Copyright (c) 2005-2008, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#


__all__ = ['NotifyWdg']

from pyasm.common import Container
from pyasm.web import DivWdg

from tactic.ui.common import BaseRefreshWdg

class NotifyWdg(BaseRefreshWdg):

    def get_display(my):

        top = my.top

        top.set_id("spt_notify_top")

        top.add_style("position: fixed")
        top.add_style("bottom: -30")
        top.add_style("left: 0")
        top.add_style("right: 0")
        top.add_style("z-index: 1000")

        top.add_color("background", "background2", 10)
        top.add_style("height: 20px")
        top.add_style("width: 100%")
        top.add_style("padding: 5px")
        top.add_border()


        msg_div = DivWdg()
        top.add(msg_div)
        msg_div.add_class("spt_notify_message")




        top.add_behavior( {
            'type': 'load',
            'cbjs_action': '''
spt.notify = {};

spt.notify.show = function() {
    new Fx.Tween('spt_notify_top').start('bottom', 0);
}

spt.notify.hide = function() {
    new Fx.Tween('spt_notify_top').start('bottom', -30);
}


spt.notify.set_message = function(message) {
    var el = $('spt_notify_top').getElement(".spt_notify_message");
    el.innerHTML = message;
}



spt.notify.show_message = function(message, duration) {
    if (typeof(duration) == 'undefined') {
        duration = 2000;
    }

    spt.notify.show();
    spt.notify.set_message(message);
    setTimeout( function() {
        spt.notify.hide();
    }, duration );

}



            '''
        } )


        return top



