###########################################################
#
# Copyright (c) 2011, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#


__all__ = ['SimpleCheckinWdg']

from pyasm.common import Environment, jsonloads, jsondumps
from pyasm.biz import Project
from pyasm.web import DivWdg, Table, WidgetSettings
from tactic.ui.common import BaseRefreshWdg
from pyasm.widget import IconWdg, RadioWdg
from tactic.ui.widget import IconButtonWdg


class SimpleCheckinWdg(BaseRefreshWdg):


    def get_display(my):

        search_key = my.kwargs.get("search_key")

        top = my.top
        #top.add_color("background", "background")
        #top.add_border()
        top.add_style("min-width: 600px")
        top.add_style("width: 100%")



        content = DivWdg()
        top.add(content)
        content.add_border()
        content.add_color("background", "background3")
        content.add_color("color", "background3")
        content.add_style("width: 600px")
        content.add_style("margin: 30px auto 30px auto")

        from tactic.ui.widget import CheckinWdg
        content.add_behavior( {
            'type': 'load',
            'cbjs_action': CheckinWdg.get_onload_js()
        } )



        button_div = DivWdg()
        content.add(button_div)
        button = IconWdg(title="Check-In", icon=IconWdg.PUBLISH_LG)
        button_div.add(button)
        button_div.set_box_shadow("1px 1px 1px 1px")
        button_div.add_style("width: 50px")
        button_div.add_style("height: 50px")
        button_div.add_style("float: left")
        button_div.add_class("hand")

        button_div.add_style("margin: 20px 50px 20px 200px")


        button.add_behavior( {
            'type': 'click_up',
            'search_key': search_key,
            'cbjs_action': '''
            var class_name = 'tactic.ui.widget.CheckinWdg';
            var applet = spt.Applet.get();


            spt.app_busy.show("Add Files To Check-in")


            var current_dir = null;
            var is_sandbox = false;
            var values = spt.checkin.browse_folder(current_dir, is_sandbox);

            var file_paths = values.file_paths;
            if (file_paths.length == 0) {
                spt.alert("No files selected to check-in");
                return;
            }

            spt.app_busy.hide();

            var kwargs = {
                'search_key': bvr.search_key,
                'show_links': false,
                'show_history': false,
                'close_on_publish': true
            }

            // FIXME: not sure why we need to use the complex method below
            // but this is what is used in CheckinButtonElementWdg
            //spt.panel.load_popup("checkin_widget", class_name, kwargs, values);
            var options=  {
                title: "Check-in Widget",
                class_name: 'tactic.ui.widget.CheckinWdg',
                popup_id: 'checkin_widget'
            };
            var bvr2 = {};
            bvr2.options = options;
            bvr2.values = values;
            bvr2.args = kwargs;
            spt.popup.get_widget({}, bvr2)



            '''
        } )


        button_div = DivWdg()
        content.add(button_div)
        button = IconWdg(title="Check-In", icon=IconWdg.CHECK_OUT_LG)
        button_div.add(button)
        button_div.set_box_shadow("1px 1px 1px 1px")
        button_div.add_style("width: 50px")
        button_div.add_style("height: 50px")
        button_div.add_style("float: left")
        button_div.add_style("margin: 20px")
        button_div.add_class("hand")



        button.add_behavior( {
            'type': 'click_up',
            'search_key': search_key,
            'cbjs_action': '''
            var class_name = 'tactic.ui.checkin.SObjectDirListWdg';
            var kwargs = {
                search_keys: [bvr.search_key]
            };
            spt.panel.load_popup("Check-out", class_name, kwargs);
            '''
        } )

 

        content.add("<br clear='all'/>")
        return top

